<template>
  <div class="signIn-input-wrapper">
    <input
      class="signIn-input"
      :disabled="disabled"
      :class="error ? 'error' : ''"
      type="text"
      :placeholder="label"
      :value="val"
      :maxlength="maxLength"
      @input="updateInput">
    <div
      class="signIn-input-btn"
      @click="refresh">
      <img
        src="~/static/icons/refresh.png"
        class="signIn-input-img"
        :class="rotate ? 'rotate-instant' : ''"
        alt="">
    </div>
    <div
      class="signIn-input-btn"
      @click="$emit('info')">
      <v-popover
        offset="16"
        placement="top">
        <div class="flex flex-middle">
          <img
            src="~/static/icons/information.png"
            class="signIn-input-img"
            alt="">
        </div>
        <template slot="popover">
          {{$t('helpers.signUpAccountName')}}
        </template>
      </v-popover>
    </div>
  </div>
</template>

<script>
  export default {
    name: "Input",
    props: {
      disabled: {
        type: Boolean,
        default: false
      },
      error: {
        type: Boolean,
        default: false
      },
      label: {
        type: String,
        default: 'Placeholder'
      },
      value: {
        type: String || Number,
        default: ''
      },
      maxLength: {
        type: Number,
      }
    },
    data() {
      return {
        rotate: false
      }
    },
    computed: {
      val() {
        return this.value;
      }
    },
    methods: {
      updateInput(val) {
        this.$emit('input', val.target.value);
      },
      refresh() {
        this.rotate = true;
        this.$emit('refresh');
        setTimeout(_ => {
          this.$nextTick(_ => {
            this.rotate = false;
          });
        }, 1000);
      }
    }
  }
</script>
